#include <dos.h>
#include <math.h>

void setScreen13();
void clearScreen(char color);
void pixel(int x, int y, char color);
void drawbox(int x1, int y1, int x2, int y2, char color);

void setScreen13()
{
 asm {
	mov ax, 13h
	int 10h
		 }
}

void clearScreen(char color)
{
 asm {
	mov ax, 0a000h
	mov es, ax

	xor ax, ax
	mov cx, 0fa00h
	mov di, ax
	mov al, [color]
	rep stosb
		 }
}


void pixel(int x, int y, char color)
{
 asm {
	mov ax, 0a000h
	mov es, ax

	mov ax, [y]
	mov bx, 320
	mul bx
	add ax, [x]
	mov di, ax
	mov al, [color]

	mov [es:di], al
		 }
}

void drawbox(int x1, int y1, int x2, int y2, char color)
{
 int oldx1 = x1;

 asm {
  mov ax, 0a000h
  mov es, ax
	 }
drawloop:
 asm {
  mov ax, [y1]
  mov bx, 320
  mul bx
  add ax, [x1]
  mov di, ax

  mov al, [color]
  mov [es:di], al

  inc [x1]
  mov ax, [x1]
  cmp ax, [x2]
  jle drawloop

  mov ax, [oldx1]
  mov [x1], ax
  inc [y1]
  mov ax, [y1]
  cmp ax, [y2]
  jle drawloop
	 }
}

/*------- sample program --------*/
void main ()
{
 int i,x,y;

 setScreen13();

 clearScreen(1);

 drawbox(50,70,100,120,40);

 for(i = 0; i < 320; i++)
 {
  pixel(i, (5 * sin(i / 5) + 100), 10);
 }

 sleep(2);
}
